#include "hjklib.h"
#include "pkt_struct.h"

struct in_addr {
    unsigned long s_addr;
};

u_short in_chksum(u_short*,int);
char *itos(unsigned long);
char *itos(unsigned long ip){
   struct in_addr in;
   in.s_addr=ip;
   return((char *)(inet_ntoa(in)));   
}

u_short in_chksum(u_short *ptr, int nbytes)
{
  register long           sum;            /* assumes long == 32 bits */
  u_short                 oddbyte;
  register u_short        answer;         /* assumes u_short == 16 bits */
  sum = 0;
  while (nbytes > 1)
  {
    sum += *ptr++;
    nbytes -= 2;
  }
  if (nbytes == 1)
  {
     oddbyte = 0;            /* make sure top half is zero */
     *((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
     sum += oddbyte;
  }
  sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
  sum += (sum >> 16);                     /* add carry */
  answer = ~sum;          /* ones-complement, then truncate to 16 bits */

  return((u_short) answer);
}


/* ripped */

unsigned short trans_check(unsigned char proto, void *packet, unsigned int length,
			   unsigned long source_address,
			   unsigned long dest_address)
{
   unsigned short answer;
   struct pseudohdr *pseudo;
   void *tosum;
   tosum=(void *)malloc(sizeof(struct pseudohdr)+length);
   memset(tosum,0,sizeof(struct pseudohdr)+length);
   pseudo=(struct pseudohdr *)tosum;
   pseudo->source_address=source_address;
   pseudo->dest_address=dest_address;
   pseudo->place_holder=0;
   pseudo->protocol=proto;
   pseudo->length=htons(length);
   memcpy(tosum+sizeof(struct pseudohdr),packet,length);
   answer=in_chksum((u_short *)tosum,sizeof(struct pseudohdr)+length);
   free(tosum);
   return answer;
}
