#include "order.h"
#ifndef _STDLIB_H
#include <stdlib.h>
#endif

// #include <netinet/in.h>
struct iphdr{
#ifdef BIG_ENDIAN_BITFIELD
   unsigned int version:4;
   unsigned int ihl:4;
#else
   unsigned int ihl:4;
   unsigned int version:4;
#endif
   unsigned char tos;
   unsigned short tot_len;
   unsigned short id;
   unsigned short frag_off;
   unsigned char ttl;
   unsigned char protocol;
   unsigned short check;
   unsigned long saddr;
   unsigned long daddr;
};

struct tcphdr{
   unsigned short source;
   unsigned short dest;
   unsigned long seq;
   unsigned long ack_seq;
#ifdef BIG_ENDIAN_BITFIELD
   unsigned short doff:4;
   unsigned short res1:4;
   unsigned short res2:2;
   unsigned short urg:1;
   unsigned short ack:1;
   unsigned short psh:1;
   unsigned short rst:1;
   unsigned short syn:1;
   unsigned short fin:1;
#else
   unsigned short res1:4;
   unsigned short doff:4;
   unsigned short fin:1;
   unsigned short syn:1;
   unsigned short rst:1;
   unsigned short psh:1;
   unsigned short ack:1;
   unsigned short urg:1;
   unsigned short res2:2;
#endif
   unsigned short window;
   unsigned short check;
   unsigned short urg_ptr;
};

struct pseudohdr{
   unsigned long source_address;
   unsigned long dest_address;
   unsigned char place_holder;
   unsigned char protocol;
   unsigned short length;
};
