#include <stdio.h>
#include <stdlib.h>
#include "hjklib.h"

hs hjkconnect(int,u_short);
hs conn_rec(struct connection *,u_short);
hs hjkconnect_par(u_long,u_short,u_long,u_short,u_short);

hs hjkconnect(int index,u_short TYPE){
   struct connection *rec;
   rec=(struct connection *)get_record(index);
   return((struct connection *)conn_rec(rec,TYPE));
}

struct connection* conn_rec(struct connection *rec,u_short TYPE){
   clnhijack(rec);
   hijack(rec);
   switch(TYPE){
    default:
    case TALK_SERVER:
      rec->serv_hijack=1;
      break;
    case TALK_CLIENT:
      rec->serv_hijack=0;
   }
   return(rec);
}

struct connection* hjkconnect_par(u_long saddr,u_short sport,u_long daddr,
				  u_short dport,u_short TYPE){
   struct connection *rec;
   rec=(struct connection *)search_connection(saddr,sport,daddr,dport);
   return(conn_rec(rec,TYPE));
}
