#include <stdio.h>
#include <stdlib.h>
#include "hjklib.h"

unsigned short hjkrecv(hs,char *,int,u_char);
unsigned short hjksend(hs,char *,int,u_char);
unsigned short hjkclose(hs,u_char);



unsigned short hjkrecv(hs rec,char *buf,int len,u_char FLAGS){
   char *tmp;
   int hm;
   
   while(rec->h_buf.len==0); /* blocking */
   if(len > rec->h_buf.len){
      memcpy(buf,rec->h_buf.buf_ptr,rec->h_buf.len);
      free(rec->h_buf.buf_ptr);
      rec->h_buf.buf_ptr=NULL;
      hm=rec->h_buf.len;
      rec->h_buf.len=0;
   }
   else{
      memcpy(buf,rec->h_buf.buf_ptr,len);
      tmp=(char *)malloc(rec->h_buf.len-len);
      memcpy(tmp,rec->h_buf.buf_ptr+len,rec->h_buf.len-len);
      free(rec->h_buf.buf_ptr);
      rec->h_buf.buf_ptr=tmp;
      rec->h_buf.len-=len;
      hm=len;
   }
   return(hm);
}

unsigned short hjksend(hs rec,char *buf,int len,u_char flags){
   int times=1;
   if(flags==1)times+=4;
   if(rec->serv_hijack)
     send_tcp(rec,1,0,1,1,0,buf,len,times);
   else
     send_tcp(rec,0,0,1,1,0,buf,len,times);
   
}

unsigned short hjkclose(hs rec,u_char flags){
   if(flags==QUIETLY){
      send_tcp(rec,0,0,0,0,1,NULL,0,1);
      rec->send_fin=1;
   }
   else
     send_tcp(rec,1,1,1,0,0,NULL,0,1);
}
